<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;object-0.27.1&#x2F;src&#x2F;read&#x2F;macho&#x2F;dyld_cache.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>dyld_cache.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../../storage.js"></script><script src="../../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../../object/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::slice</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::read</span>::{<span class="ident">Error</span>, <span class="ident">File</span>, <span class="ident">ReadError</span>, <span class="ident">ReadRef</span>, <span class="prelude-ty">Result</span>};
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">macho</span>, <span class="ident">Architecture</span>, <span class="ident">Endian</span>, <span class="ident">Endianness</span>};

<span class="doccomment">/// A parsed representation of the dyld shared cache.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DyldCache</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span> <span class="op">=</span> <span class="ident">Endianness</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">E</span>: <span class="ident">Endian</span>,
    <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
{
    <span class="ident">endian</span>: <span class="ident">E</span>,
    <span class="ident">data</span>: <span class="ident">R</span>,
    <span class="ident">header</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">macho::DyldCacheHeader</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>,
    <span class="ident">mappings</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">macho::DyldCacheMappingInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>],
    <span class="ident">images</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">macho::DyldCacheImageInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>],
    <span class="ident">arch</span>: <span class="ident">Architecture</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">DyldCache</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">E</span>: <span class="ident">Endian</span>,
    <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
{
    <span class="doccomment">/// Parse the raw dyld shared cache data.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse</span>(<span class="ident">data</span>: <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">header</span> <span class="op">=</span> <span class="ident">macho::DyldCacheHeader::parse</span>(<span class="ident">data</span>)<span class="question-mark">?</span>;
        <span class="kw">let</span> (<span class="ident">arch</span>, <span class="ident">endian</span>) <span class="op">=</span> <span class="ident">header</span>.<span class="ident">parse_magic</span>()<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">mappings</span> <span class="op">=</span> <span class="ident">header</span>.<span class="ident">mappings</span>(<span class="ident">endian</span>, <span class="ident">data</span>)<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">images</span> <span class="op">=</span> <span class="ident">header</span>.<span class="ident">images</span>(<span class="ident">endian</span>, <span class="ident">data</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="ident">DyldCache</span> {
            <span class="ident">endian</span>,
            <span class="ident">data</span>,
            <span class="ident">header</span>,
            <span class="ident">mappings</span>,
            <span class="ident">images</span>,
            <span class="ident">arch</span>,
        })
    }

    <span class="doccomment">/// Get the architecture type of the file.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">architecture</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Architecture</span> {
        <span class="self">self</span>.<span class="ident">arch</span>
    }

    <span class="doccomment">/// Get the endianness of the file.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">endianness</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Endianness</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">is_little_endian</span>() {
            <span class="ident">Endianness::Little</span>
        } <span class="kw">else</span> {
            <span class="ident">Endianness::Big</span>
        }
    }

    <span class="doccomment">/// Return true if the file is little endian, false if it is big endian.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_little_endian</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">endian</span>.<span class="ident">is_little_endian</span>()
    }

    <span class="doccomment">/// Iterate over the images in this cache.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">images</span><span class="op">&lt;</span><span class="lifetime">&#39;cache</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;cache</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">DyldCacheImageIterator</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="lifetime">&#39;cache</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span> {
        <span class="ident">DyldCacheImageIterator</span> {
            <span class="ident">cache</span>: <span class="self">self</span>,
            <span class="ident">iter</span>: <span class="self">self</span>.<span class="ident">images</span>.<span class="ident">iter</span>(),
        }
    }
}

<span class="doccomment">/// An iterator over all the images (dylibs) in the dyld shared cache.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DyldCacheImageIterator</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="lifetime">&#39;cache</span>, <span class="ident">E</span> <span class="op">=</span> <span class="ident">Endianness</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">E</span>: <span class="ident">Endian</span>,
    <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
{
    <span class="ident">cache</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;cache</span> <span class="ident">DyldCache</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span>,
    <span class="ident">iter</span>: <span class="ident">slice::Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">macho::DyldCacheImageInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="lifetime">&#39;cache</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">DyldCacheImageIterator</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="lifetime">&#39;cache</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">E</span>: <span class="ident">Endian</span>,
    <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
{
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">DyldCacheImage</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span>;

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">DyldCacheImage</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">image_info</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">iter</span>.<span class="ident">next</span>()<span class="question-mark">?</span>;
        <span class="prelude-val">Some</span>(<span class="ident">DyldCacheImage</span> {
            <span class="ident">endian</span>: <span class="self">self</span>.<span class="ident">cache</span>.<span class="ident">endian</span>,
            <span class="ident">data</span>: <span class="self">self</span>.<span class="ident">cache</span>.<span class="ident">data</span>,
            <span class="ident">mappings</span>: <span class="self">self</span>.<span class="ident">cache</span>.<span class="ident">mappings</span>,
            <span class="ident">image_info</span>,
        })
    }
}

<span class="doccomment">/// One image (dylib) from inside the dyld shared cache.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DyldCacheImage</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span> <span class="op">=</span> <span class="ident">Endianness</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">E</span>: <span class="ident">Endian</span>,
    <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
{
    <span class="ident">endian</span>: <span class="ident">E</span>,
    <span class="ident">data</span>: <span class="ident">R</span>,
    <span class="ident">mappings</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">macho::DyldCacheMappingInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>],
    <span class="ident">image_info</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">macho::DyldCacheImageInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">DyldCacheImage</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">E</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">E</span>: <span class="ident">Endian</span>,
    <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
{
    <span class="doccomment">/// The file system path of this image.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">path</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">str</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">path</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">image_info</span>.<span class="ident">path</span>(<span class="self">self</span>.<span class="ident">endian</span>, <span class="self">self</span>.<span class="ident">data</span>)<span class="question-mark">?</span>;
        <span class="comment">// The path should always be ascii, so from_utf8 should alway succeed.</span>
        <span class="kw">let</span> <span class="ident">path</span> <span class="op">=</span> <span class="ident">core::str::from_utf8</span>(<span class="ident">path</span>).<span class="ident">map_err</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">Error</span>(<span class="string">&quot;Path string not valid utf-8&quot;</span>))<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="ident">path</span>)
    }

    <span class="doccomment">/// The offset in the dyld cache file where this image starts.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">file_offset</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">image_info</span>.<span class="ident">file_offset</span>(<span class="self">self</span>.<span class="ident">endian</span>, <span class="self">self</span>.<span class="ident">mappings</span>)
    }

    <span class="doccomment">/// Parse this image into an Object.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse_object</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">File</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="ident">File::parse_at</span>(<span class="self">self</span>.<span class="ident">data</span>, <span class="self">self</span>.<span class="ident">file_offset</span>()<span class="question-mark">?</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">E</span>: <span class="ident">Endian</span><span class="op">&gt;</span> <span class="ident">macho::DyldCacheHeader</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Read the dyld cache header.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="self">Self</span><span class="op">&gt;</span> {
        <span class="ident">data</span>.<span class="ident">read_at</span>::<span class="op">&lt;</span><span class="ident">macho::DyldCacheHeader</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="number">0</span>)
            .<span class="ident">read_error</span>(<span class="string">&quot;Invalid dyld cache header size or alignment&quot;</span>)
    }

    <span class="doccomment">/// Returns (arch, endian) based on the magic string.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse_magic</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(<span class="ident">Architecture</span>, <span class="ident">E</span>)<span class="op">&gt;</span> {
        <span class="kw">let</span> (<span class="ident">arch</span>, <span class="ident">is_big_endian</span>) <span class="op">=</span> <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">magic</span> {
            <span class="string">b&quot;dyld_v1    i386\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::I386</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1  x86_64\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::X86_64</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1 x86_64h\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::X86_64</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1     ppc\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::PowerPc</span>, <span class="bool-val">true</span>),
            <span class="string">b&quot;dyld_v1   armv6\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::Arm</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1   armv7\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::Arm</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1  armv7f\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::Arm</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1  armv7s\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::Arm</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1  armv7k\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::Arm</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1   arm64\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::Aarch64</span>, <span class="bool-val">false</span>),
            <span class="string">b&quot;dyld_v1  arm64e\0&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">Architecture::Aarch64</span>, <span class="bool-val">false</span>),
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error</span>(<span class="string">&quot;Unrecognized dyld cache magic&quot;</span>)),
        };
        <span class="kw">let</span> <span class="ident">endian</span> <span class="op">=</span>
            <span class="ident">E::from_big_endian</span>(<span class="ident">is_big_endian</span>).<span class="ident">read_error</span>(<span class="string">&quot;Unsupported dyld cache endian&quot;</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>((<span class="ident">arch</span>, <span class="ident">endian</span>))
    }

    <span class="doccomment">/// Return the mapping information table.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">mappings</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">endian</span>: <span class="ident">E</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">macho::DyldCacheMappingInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>]<span class="op">&gt;</span> {
        <span class="ident">data</span>.<span class="ident">read_slice_at</span>::<span class="op">&lt;</span><span class="ident">macho::DyldCacheMappingInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span><span class="op">&gt;</span>(
            <span class="self">self</span>.<span class="ident">mapping_offset</span>.<span class="ident">get</span>(<span class="ident">endian</span>).<span class="ident">into</span>(),
            <span class="self">self</span>.<span class="ident">mapping_count</span>.<span class="ident">get</span>(<span class="ident">endian</span>) <span class="kw">as</span> <span class="ident">usize</span>,
        )
        .<span class="ident">read_error</span>(<span class="string">&quot;Invalid dyld cache mapping size or alignment&quot;</span>)
    }

    <span class="doccomment">/// Return the image information table.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">images</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">endian</span>: <span class="ident">E</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">macho::DyldCacheImageInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>]<span class="op">&gt;</span> {
        <span class="ident">data</span>.<span class="ident">read_slice_at</span>::<span class="op">&lt;</span><span class="ident">macho::DyldCacheImageInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span><span class="op">&gt;</span>(
            <span class="self">self</span>.<span class="ident">images_offset</span>.<span class="ident">get</span>(<span class="ident">endian</span>).<span class="ident">into</span>(),
            <span class="self">self</span>.<span class="ident">images_count</span>.<span class="ident">get</span>(<span class="ident">endian</span>) <span class="kw">as</span> <span class="ident">usize</span>,
        )
        .<span class="ident">read_error</span>(<span class="string">&quot;Invalid dyld cache image size or alignment&quot;</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">E</span>: <span class="ident">Endian</span><span class="op">&gt;</span> <span class="ident">macho::DyldCacheImageInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span> {
    <span class="doccomment">/// The file system path of this image.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">path</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">endian</span>: <span class="ident">E</span>, <span class="ident">data</span>: <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">r_start</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">path_file_offset</span>.<span class="ident">get</span>(<span class="ident">endian</span>).<span class="ident">into</span>();
        <span class="kw">let</span> <span class="ident">r_end</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">len</span>().<span class="ident">read_error</span>(<span class="string">&quot;Couldn&#39;t get data len()&quot;</span>)<span class="question-mark">?</span>;
        <span class="ident">data</span>.<span class="ident">read_bytes_at_until</span>(<span class="ident">r_start</span>..<span class="ident">r_end</span>, <span class="number">0</span>)
            .<span class="ident">read_error</span>(<span class="string">&quot;Couldn&#39;t read dyld cache image path&quot;</span>)
    }

    <span class="doccomment">/// Find the file offset of the image by looking up its address in the mappings.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">file_offset</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">endian</span>: <span class="ident">E</span>,
        <span class="ident">mappings</span>: <span class="kw-2">&amp;</span>[<span class="ident">macho::DyldCacheMappingInfo</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>],
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">address</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">address</span>.<span class="ident">get</span>(<span class="ident">endian</span>);
        <span class="kw">for</span> <span class="ident">mapping</span> <span class="kw">in</span> <span class="ident">mappings</span> {
            <span class="kw">let</span> <span class="ident">mapping_address</span> <span class="op">=</span> <span class="ident">mapping</span>.<span class="ident">address</span>.<span class="ident">get</span>(<span class="ident">endian</span>);
            <span class="kw">if</span> <span class="ident">address</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">mapping_address</span>
                <span class="op">&amp;&amp;</span> <span class="ident">address</span> <span class="op">&lt;</span> <span class="ident">mapping_address</span>.<span class="ident">wrapping_add</span>(<span class="ident">mapping</span>.<span class="ident">size</span>.<span class="ident">get</span>(<span class="ident">endian</span>))
            {
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">address</span> <span class="op">-</span> <span class="ident">mapping_address</span> <span class="op">+</span> <span class="ident">mapping</span>.<span class="ident">file_offset</span>.<span class="ident">get</span>(<span class="ident">endian</span>));
            }
        }
        <span class="prelude-val">Err</span>(<span class="ident">Error</span>(<span class="string">&quot;Invalid dyld cache image address&quot;</span>))
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="object" data-search-index-js="../../../../search-index.js" data-search-js="../../../../search.js"></div>
    <script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script>
</body></html>